## R-1.5.0.tgz

=== src/gnuwin32/Makefile ===
include MkRules
include RWVERSION

ifneq ($(strip $(BUILD)),CROSS)
ifneq ($(strip $(wildcard Rpwd.exe)),)
all: Rpwd.exe rbuild rpackage rdocs
else
all: Rpwd.exe
	$(MAKE) rbuild rpackage rdocs
endif
else
all: Rpwd.exe rbuild rpackage rdocs
endif

PACKAGES = base ctest eda lqs methods modreg mva nls splines stepfun tools ts
ALLPACKAGES = $(PACKAGES) tcltk

## must be absolute and space-free paths
ifneq ($(strip $(BUILD)),CROSS)
RHOME = $(shell ./Rpwd.exe ../..)
PKGD = $(shell ./Rpwd.exe $(PKGDIR))
else
RHOME = $(shell perl pwd.pl ../..)
PKGD = $(shell perl pwd.pl $(PKGDIR))
endif

RLIB = $(RHOME)/library
PKGDIR = $(RHOME)/src/library

OPTFLAGS=-O2 -Wall -pedantic
## use FOPTFLAGS where complex*16 is used.
FOPTFLAGS=-O2 -Wall
ifdef DEBUG
 OPTFLAGS+=-g
 FOPTFLAGS+=-g
 DLLFLAGS=
else
 DLLFLAGS=-s
endif

R-DLLFLAGS = -mwindows
R-DLLLIBS =-L. $(FLIBS) -lcomctl32 -lversion
FLIBS+=-lRblas
SOURCES = $(filter-out malloc.c blas00.c,$(wildcard *.c *.f))
OBJS = $(SOURCES:.c=.o)
MAINLIBS = libmain.a libappl.a libmath.a
EXTRALIBS = ga.a gl.a xdr.a ../extra/zlib/libz.a

LIBFILES = $(foreach i, $(ALLPACKAGES), ../../library/$i) ../../library/R.css
PKGS = $(foreach i,$(PACKAGES),pkg-$i)
PKGCLEAN = $(foreach i,$(ALLPACKAGES),pkgclean-$i)

# flags to ensure that Doug Lea's malloc is used:
ifdef LEA_MALLOC
extra-CFLAGS+=-DLEA_MALLOC
OBJS-EXTRA=malloc.o
endif

.PHONY:  clean veryclean  rlibs fixfiles front-ends rmodules


# separate as Tcl/Tk headers are needed.
tcl: 
	$(MAKE) STAMP=NO pkg-tcltk

CFLAGS = $(OPTFLAGS) -I../include -I. -DHAVE_CONFIG_H -DR_DLL_BUILD
FFLAGS = $(OPTFLAGS)

Rpwd.exe: front-ends/Rpwd.exe
	$(CP) $< $@

front-ends/Rpwd.exe:
	$(MAKE) -C front-ends Rpwd

## watch out: R.dll and Rblas.dll depend on each other.
rbuild: fixfiles rlibs makeMakedeps libRblas.a ../../bin/R.dll libR.a \
	 ../../bin/Rblas.dll CHTML front-ends COPYRIGHTS rmodules

rpackage: fixed/fixdesc ../../library/R.css
	$(MAKE) STAMP=NO $(PKGS)

rinstaller:
	$(MAKE) -C installer RPREFIX=$(RPREFIX)

rlibs:
	$(MAKE) -C ../appl  OPTFLAGS='$(OPTFLAGS)' -f Makefile.win
	$(MAKE) -C ../main  OPTFLAGS='$(OPTFLAGS)' -f Makefile.win
	$(MAKE) -C ../nmath OPTFLAGS='$(OPTFLAGS)' -f Makefile.win
	$(MAKE) -C ./graphapp
	$(MAKE) -C ./getline
	$(MAKE) -C ../extra/xdr -f Makefile.win

rmodules: libRm.a
	$(MAKE) -C ../modules OPTFLAGS='$(OPTFLAGS)' FOPTFLAGS='$(FOPTFLAGS)' \
	  -f Makefile.win

COPYRIGHTS: $(RHOME)/COPYRIGHTS COPYRIGHTS.win
	cat $^ > $@


fixfiles:
	$(MKDIR) -p ../../bin
	$(MAKE) -C ./fixed

fixed/fixdesc:
	sh fixed/GETDESC $(ALLPACKAGES)

dllversion.o: ../include/Rversion.h

R.dll: R.a $(OBJS-EXTRA) $(MAINLIBS) $(EXTRALIBS) dllversion.o

Rdll: makeMakedeps ../../bin/R.dll

../../bin/R.dll: fixfiles rlibs R.dll
	$(MKDIR) -p ../../bin
	$(CP) R.dll ../../bin/

front-ends: libR.a
	$(MAKE) -C front-ends

R.a: $(OBJS)
	@$(ECHO) -------- Building $@ --------
	$(AR) cr R.a $^
	$(RANLIB) R.a


# R.dll exports all global symbols BUT import library (libR.a)
# only (all functions) + (global vars listed in exported-vars))

libR.a:  R.exp
	$(DLLTOOL) $(DLLTOOLFLAGS) $(R-DLLTOOLFLAGS) --dllname R.dll --def R.exp --output-lib libR.a

R.exp: R.exp1
	(diff R.exp R.exp1 > /dev/null) || $(CP) R.exp1 R.exp

R.exp1: R.a $(MAINLIBS) $(EXTRALIBS) exported-vars
	$(ECHO) EXPORTS > $@
	$(NM) R.a $(MAINLIBS) $(EXTRALIBS) > RDefs
	$(SED) -n '/^........ [T] _/s/^........ [T] _/ /p' RDefs >> $@
	$(CAT) exported-vars >> $@
	$(RM) RDefs

# An additional import library needed for the modules that uses R.dll's malloc/.../free
libRm.a:  Rm.exp
	$(DLLTOOL) $(DLLTOOLFLAGS) $(R-DLLTOOLFLAGS) --dllname R.dll --def Rm.exp --output-lib libRm.a

Rm.exp: Rm.exp1
	(diff Rm.exp Rm.exp1 > /dev/null) || $(CP) Rm.exp1 Rm.exp

Rm.exp1: $(OBJS-EXTRA)
	$(ECHO) EXPORTS > $@
	$(NM) $(OBJS-EXTRA) > RDefs
	$(SED) -n '/^........ [T] _/s/^........ [T] _/ /p' RDefs >> $@
	$(CAT) exported-vars >> $@
	$(RM) RDefs

../../library/R.css: ../../doc/html/R.css
	$(CP) $< $@

../extra/zlib/libz.a:
	$(MAKE) -C ../extra/zlib -f Makefile.win

rdocs:
	@$(MAKE) -C ../../doc/manual -f Makefile.win html BUILD=$(BUILD)


#                          ===== BLAS ======

Rblas: ../../bin/Rblas.dll

Rblas-clean:
	$(RM) ../../bin/Rblas.dll blas00.o blas00.d blas.o cmplxblas.o

Rblas-DLLLIBS=-L. -lR

libRblas.a:  Rblas.def
	$(DLLTOOL) $(DLLTOOLFLAGS) $(R-DLLTOOLFLAGS) --dllname Rblas.dll \
	  --def Rblas.def --output-lib libRblas.a

ifeq ($(strip $(USE_ATLAS)),YES)
../../bin/Rblas.dll: blas00.o dllversion.o
	@$(ECHO) -------- Building $@ --------
	$(DLL) -shared -o $@ $^ Rblas.def -L $(ATLAS_PATH) \
	   -L. -lR -lg2c -lf77blas -latlas
## suppress lots of warnings: this is a dummy
blas00.o: blas00.c
	$(CC) -O2  -c $< -o $@
else
../../bin/Rblas.dll: blas.o cmplxblas.o dllversion.o
	@$(ECHO) -------- Building $@ --------
	$(DLL) -shared -o $@ Rblas.def $^ -L. -lR

blas.o: ../appl/blas.f
	$(F77) $(FFLAGS) -c $< -o $@
cmplxblas.o: ../modules/lapack/cmplxblas.f
	$(F77) $(FOPTFLAGS) -c $< -o $@
endif


#                          ===== Packages ======

CHTML:
ifeq ($(strip $(HELP)),YES)
ifeq ($(strip $(WINHELP)),CHM)
	$(MAKE) -C ./help -f MkChmDll
endif
ifeq ($(strip $(WINHELP)),BOTH)
	$(MAKE) -C ./help -f MkChmDll
endif
endif

base-HELP = ziponly
methods-HELP = ziponly
nls-HELP = ziponly
ts-HELP = ziponly
base-ZIPDATA = zip
ts-ZIPDATA = zip

MASS-HELP = ziponly
MASS-ZIPDATA = zip

bundle-%:
	$(PERL) fixed/dobundle.pl $* $(PKGD) $(RLIB)

pkg-%:
	$(MAKE) DLLNM=$($*-DLLNM)  FLIBS="$(FLIBS)" BUILD=$(BUILD) \
	  -C $(PKGDIR)/$* PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) \
	  -f $(RHOME)/src/gnuwin32/MakePkg
	@if test -d $(RLIB)/$*/data ; then \
	  $(MAKE) $($*-ZIPDATA)data-$* ; \
	fi
ifeq ($(strip $(HELP)),YES)
	@$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) $($*-HELP)help-$*
	@$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) contents-$*
ifeq ($(strip $(WINHELP)),CHM)
	@$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) chm-$*
endif
ifeq ($(strip $(WINHELP)),BOTH)
	@$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) winhlp-$* # also makes chm
endif
endif

pkgclean-%:
	$(MAKE) DLLNM=$($*-DLLNM) RHOME=$(RHOME) BUILD=$(BUILD) \
	  -C $(PKGDIR)/$* PKG=$* -f $(RHOME)/src/gnuwin32/MakePkg clean

pkgcheck-%:
	@$(ECHO) -------- Testing package $* --------
	-@mkdir -p $(PKGDIR)/$*/check
	@$(MAKE) -C $(PKGDIR)/$*/check PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) \
	  -f $(RHOME)/src/gnuwin32/check/PkgCheck
	@if test -d $(PKGDIR)/$*/tests ; then \
	  $(MAKE) -C $(PKGDIR)/$*/tests PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) \
	    -f $(RHOME)/src/gnuwin32/check/PkgCheck tests;\
	fi

ziphelp-%:
	$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) ziphelp-$*

ziponly-%:
	$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) ziponlyhelp-$*

zipdata-%:
	@echo "  zipping data"
	@(cd $(RLIB)/$*/data; \
	  if test -f Rdata.zip ; then \
	    unzip -qou Rdata; \
	  fi; \
	  $(RM) Rdata.zip filelist ; \
	  ls -1 > filelist; \
	  zip -rmq9X Rdata * -x filelist 00Index)

data-%:
	@echo "  not zipping data"


#                          ===== cleaning ======

clean: cleanwin $(PKGCLEAN)
	$(RM) -f ../*/*.o $(WINOBJS) *.a ../*/*.d ../*/Makedeps fixed/fixdesc
	-$(MAKE) -C ../../doc/manual -f Makefile.win distclean
	-$(MAKE) -C ../nmath/standalone -f Makefile.win distclean
	-$(MAKE) -C ../modules -f Makefile.win clean
	-$(MAKE) -C ../../tests -f Makefile.win clean
	$(RM) -f ../library/methods/R/methods

distclean veryclean: clean
	$(RM) -r ../../bin ../../library ../../modules
	$(RM) ../include/config.h ../include/psignal.h \
	../include/Rconfig.h ../include/Rversion.h ../include/Rmath.h
	$(RM) ../library/*/src/*.o ../library/*/src/*.a
	$(RM) ../library/*/src/*.dll
	$(RM) -r ../library/*/check
	$(RM) R.exp Rm.exp COPYRIGHTS
	$(RM) ../../doc/html/search/index.txt ../../doc/html/index.html \
	../../doc/html/packages.html ../../doc/html/rwin.html \
	../../doc/html/rw-FAQ.html ../../doc/html/search/SearchEngine.html
	$(RM) ../../etc/Rconsole ../../etc/Rdevga ../../etc/Rprofile \
	../../etc/rgb.txt ../../share/make/wintests.mk \
	../include/Platform.h ../../tests/*.Rout ../../tests/*.Rout.fail
	$(MAKE) -C fixed distclean
	-$(MAKE) -C installer ISdistclean
	@for pkg in $(ALLPACKAGES); do \
	  $(RM) ../library/$${pkg}/DESCRIPTION; \
	done
	$(RM) Rpwd.exe # do this last of all

cleanwin:
	$(RM) *.o *.dll *.a *~ \#*\# rw*.zip R.def R.exp1 Rm.exp1\
	   .RData .Rhistory Makedeps *.d
	$(MAKE) -C graphapp clean
	$(MAKE) -C fixed clean
	$(MAKE) -C getline clean
	$(MAKE) -C help clean
	$(MAKE) -C front-ends clean
	$(MAKE) -C ../extra/xdr -f Makefile.win clean
	$(MAKE) -C bitmap clean
	-$(MAKE) -C installer clean ISclean


#                          ===== testing ======

# tests
check test: test-Specific pkgtests

test-Specific:
	-@$(MAKE) -C $(RHOME)/tests -f $(RHOME)/tests/Makefile.win clean
	-@$(MAKE) -C $(RHOME)/tests -f $(RHOME)/tests/Makefile.win RHOME=$(RHOME)


PKGS-CHK = $(foreach i, $(PACKAGES), pkgcheck-$i)
pkgtests: $(PKGS-CHK)


#                          ===== documentation ======

docs manuals:
	@$(MAKE) -C $(RHOME)/doc/manual -f Makefile.win clean BUILD=$(BUILD)
	@$(MAKE) -C $(RHOME)/doc/manual -f Makefile.win \
	  R_PKGS='$(ALLPACKAGES)' BUILD=$(BUILD)
	@$(MAKE) ziponly-base


## ===================== Maintainer targets ========================

RVER = $(shell cut -d' ' -f1 ../../VERSION | sed -n 1p)

docfiles:
	$(MAKE) -f Makefile.docfiles

bitmapdll:
	$(MAKE) -C bitmap

distribution: bindist packagedist docsdist

bindist: tcl bitmapdll docfiles
	$(RM) -r $(RPREFIX)
	$(MKDIR) $(RPREFIX)
	$(CP) -pr ../../bin ../../modules ../../afm $(RPREFIX)
	$(MKDIR) $(RPREFIX)/library
	$(CP) -pr $(LIBFILES) $(RPREFIX)/library
# morley.tab is needed for R-intro Appendix A
	$(CP) -p ../library/base/data/morley.tab $(RPREFIX)/library/base/data
	$(RM) $(RPREFIX)/*/Makefile.in
	(cd $(RPREFIX)/bin; $(RM) Rcmd.exe INSTALL REMOVE SHLIB build check \
	   massage-Examples Rd2dvi.sh Rd2txt Rdconv Rdiff.sh Rdindex \
           Sd2Rd Rprof)
	$(MKDIR) $(RPREFIX)/etc
	$(CP) -p ../../etc/Rprofile $(RPREFIX)/etc/Rprofile
	$(CP) -p ../../etc/Rconsole $(RPREFIX)/etc/Rconsole
	$(CP) -p ../../etc/Rdevga $(RPREFIX)/etc/Rdevga
	$(CP) -p ../../etc/rgb.txt $(RPREFIX)/etc/rgb.txt
	$(MKDIR) -p $(RPREFIX)/doc/manual  $(RPREFIX)/share/texmf
	$(CP) -pr ../../doc/html $(RPREFIX)/doc
	$(CP) -p ../../doc/manual/*.html $(RPREFIX)/doc/manual
	$(CP) -pr ../../share/texmf $(RPREFIX)/share
	$(CP) -p ../../AUTHORS ../../COPYING COPYRIGHTS ../../FAQ ../../NEWS \
		../../THANKS ../../Y2K $(RPREFIX)
	$(SED) -e s/@RWVER@/$(RPREFIX)/g \
	  -e s/@RVER@/$(RVER)/g readme > $(RPREFIX)/README
	$(CP) -p rw-faq $(RPREFIX)/rw-FAQ
	$(CP) -p CHANGES README.Rterm $(RPREFIX)
	find $(RPREFIX) -name CVS -prune -exec rm -rf \{\} \;
# convert docs and batch files to CRLF: might already be on Windows, though.
ifeq ($(strip $(BUILD)),CROSS)
	zip -l dosfiles.zip $(RPREFIX)/* $(RPREFIX)/bin/*.bat
	unzip -ao dosfiles.zip
else
	zip dosfiles.zip $(RPREFIX)/* $(RPREFIX)/bin/*.bat
	unzip -o dosfiles.zip
endif
	$(RM) dosfiles.zip
	$(RM) $(RPREFIX)b.zip $(RPREFIX)m.zip $(RPREFIX)h.zip \
	   $(RPREFIX)w.zip $(RPREFIX)l.zip $(RPREFIX)ch.zip
	$(RM) anindex.zip
	zip -mrX anindex.zip $(RPREFIX)/library/*/help/AnIndex
	zip -mr9X $(RPREFIX)h.zip $(RPREFIX)/library/*/help
	unzip anindex.zip
	$(RM) anindex.zip
	$(RM) $(RPREFIX)/doc/manual/R-FAQ.html
	zip -rm9X $(RPREFIX)w.zip $(RPREFIX)/doc/html \
          $(RPREFIX)/doc/manual/*.html \
	  $(RPREFIX)/library/*/html $(RPREFIX)/library/R.css
	-zip -rm9X $(RPREFIX)ch.zip $(RPREFIX)/library/*/chtml \
	  $(RPREFIX)/bin/Rchtml.dll
#	$(RM) $(RPREFIX)/library/*/winhlp/*.GID
#	-zip -rm9X $(RPREFIX)wh.zip $(RPREFIX)/library/*/winhlp
	zip -rm9X $(RPREFIX)l.zip $(RPREFIX)/library/*/latex $(RPREFIX)/share/texmf
	$(RM) -r $(RPREFIX)/doc
	mkdir -p  $(RPREFIX)/doc/html
	$(CP) -p ../../doc/html/faq.html ../../doc/html/rw-FAQ.html \
	  $(RPREFIX)/doc/html
	zip -rm9X $(RPREFIX)m.zip $(RPREFIX)/library/*/man
	zip -r9X $(RPREFIX)b.zip $(RPREFIX)

=== src/gnuwin32/bitmap/Makefile ===
include ../MkRules

JPEGDIR=jpeg-6b

all: buildzlib buildpng buildjpeg Rbitmap.dll installdll

buildzlib:
#	$(MAKE) CC='$(CC)' AR='$(AR) rcs' -C zlib -f nt/Makefile.gcc libz.a
	$(MAKE) -C ../../extra/zlib -f Makefile.win

buildpng:
	$(MAKE) CC='$(CC)' RANLIB=$(RANLIB) ZLIBLIB=../../../extra/zlib ZLIBINC=../../../extra/zlib -C libpng -f scripts/makefile.std libpng.a

# jconfig.h and Makefile obtained running 'CC="gcc -mno-cygwin" ./configure'
# under CYGWIN. They are here since the configure script doesn't run 
# (I suspect) using the reduced set of tools we distribute.
buildjpeg: $(JPEGDIR)/jconfig.h Makefile.jpeg
	$(MAKE) CC='$(CC)' AR='$(AR) rc' RANLIB=$(RANLIB) -C $(JPEGDIR) -f ../Makefile.jpeg libjpeg.a

$(JPEGDIR)/jconfig.h: jconfig.h 
	$(CP) jconfig.h $(JPEGDIR)/jconfig.h

rbitmap-CFLAGS=-Wall -pedantic -DHAVE_PNG -DHAVE_JPEG -I../../extra/zlib -I./libpng -I$(JPEGDIR) -I../../include
Rbitmap-DLLLIBS=-L./libpng -lpng -L$(JPEGDIR) -ljpeg -L../ -lR
Rbitmap-DLLFLAGS=-s

Rbitmap.dll: rbitmap.o

installdll: 
	$(CP) Rbitmap.dll ../../../bin

clean:
	$(RM) *.o *.a *.dll *.def *~ \#*\#
	-$(MAKE) CC='$(CC)' -C libpng -f scripts/makefile.std clean
	-$(MAKE) CC='$(CC)' -C $(JPEGDIR) -f ../Makefile.jpeg clean

=== src/gnuwin32/fixed/Makefile ===
include ../MkRules

all: profiles fixh fixhtml fixbin fixetc fixshare

profiles: ../../../library/base/R/Rprofile

../../../library/base/R/Rprofile:  ../../library/profile/Common.R \
../../library/profile/Rprofile.gnw
	@$(ECHO) -------- Building $@ from $^--------
	mkdir -p ../../../library/base/R
	$(CAT)  $^ > $@


SED0='/^\#/d'
SED01='/Rsockfork/d'
SED1='s/F77_SUBROUTINE(\(.*\))/void * \1_();/'
SED2='s/C_FUNCTION(\(.*\))/void * \1();/'
SED3='s/F77_SUBROUTINE(\(.*\))/	{ "\1_",	\1_},/'
SED4='s/C_FUNCTION(\(.*\))/{ "\1",	\1 },/'

../FFDecl.h: ../../appl/ROUTINES
	$(SED) -e $(SED0) -e $(SED01) -e $(SED1) -e $(SED2) $< > $@
../FFTab.h: ../../appl/ROUTINES
	$(SED) -e $(SED0) -e $(SED01) -e $(SED3) -e $(SED4) $< > $@


version: ../../include/Rversion.h
fixh: version h/config.h ../FFDecl.h ../FFTab.h \
  ../../include/Rconfig.h  ../../include/Rmath.h
	$(CP) -p ./h/config.h ./h/psignal.h ../../include
	$(ECHO) done > fixh

../../include/Rconfig.h: h/config.h
	$(SED) -e 1d ../../../tools/GETCONFIG > GC
	(cd h; sh ../GC > ../../../include/Rconfig.h)
	$(RM) GC

../../include/Rversion.h: ../../../date-stamp ../../../VERSION
	$(SED) -e 1d ../../../tools/GETVERSION > ../../../tools/GV
	sh ../../../tools/GV > $@
	$(RM) ../../../tools/GV

../../include/Rmath.h: ../../include/Rmath.h.in
	$(SED) -e /@RMATH_HAVE_LOG1P@/d  -e /@RMATH_HAVE_EXPM1@/d $< > $@

../../../bin/massage-Examples: ../../../share/perl/massage-Examples.pl
	$(SED) -e 's/"contr.poly")/"contr.poly"), pager="console"/' $< > $@

../../../bin/check: ../../scripts/check.in
	$(SED) -e 1d -e "s/R CMD/Rcmd/" -e "s/Rd2dvi /Rd2dvi.sh /" $< > $@

../../../bin/build: ../../scripts/build.in
	$(SED) -e 1d -e "s/R CMD/Rcmd/" $< > $@

../../../bin/Sd2Rd: ../../scripts/Sd2Rd.in
	$(SED) -e 1d -e "s/R CMD/Rcmd/" $< > $@

../../../bin/Rdconv: ../../scripts/Rdconv.in
	$(SED) -e 1d -e s/\"unix\"/\"windows\"/ -e "s/R CMD/Rcmd/" $< > $@

../../../bin/Rdindex: ../../scripts/Rdindex.in
	$(SED) -e 1d -e s/\"unix\"/\"windows\"/ -e "s/R CMD/Rcmd/" $< > $@

../../../bin/Rdiff.sh: ../../scripts/Rdiff
	$(SED) -e 1d $< > $@

../../../bin/Rprof: ../../scripts/Rprof.in
	$(SED) -e 1d -e "s/R CMD/Rcmd/" $< > $@

fixbin: ../../../bin/massage-Examples ../../../bin/build \
	   ../../../bin/check ../../../bin/Rdconv ../../../bin/Rdindex \
	   ../../../bin/Sd2Rd ../../../bin/Rdiff.sh ../../../bin/Rprof cp2bin
	$(ECHO) done > fixbin

cp2bin: $(filter-out ./bin/CVS, $(wildcard ./bin/*))
	zip -q bins $^
	unzip -oaq bins -d  ../../..
	$(RM) bins.zip

fixhtml: $(wildcard ./html/*.html) ../../../doc/html/search/SearchEngine.html
	$(CP) -p ./html/*.html ../../../doc/html
	$(CP) -p ./html/rwin.html ../../../doc/html/index.html
	$(ECHO) done > fixhtml

fixetc: $(filter-out ./etc/CVS, $(wildcard ./etc/*))
	$(CP) -p $^ ../../../etc
	$(ECHO) done > fixetc

fixshare: ./share/tests.mk
	$(MKDIR) -p ../../../share/make
	$(CP) -p $^ ../../../share/make/wintests.mk
	$(ECHO) done > fixshare	

clean:
	$(RM) *~ */*~ fixhtml fixh fixbin fixetc fixshare

distclean: clean
	$(RM) -f ../FFDecl.h ../FFTab.h ../../../tools/GV

../../../doc/html/search/SearchEngine.html:../../../doc/KEYWORDS.db
	(cd ../../../doc; \
	cat html/search/SearchEngine-head.html > html/search/SearchEngine.html; \
	perl ../tools/keywords2html.pl KEYWORDS.db >> html/search/SearchEngine.html; \
	cat html/search/SearchEngine-foot.html >> html/search/SearchEngine.html)

=== src/gnuwin32/front-ends/Makefile ===
include ../MkRules

ifdef DEBUG
  OPTFLAGS=-g
  LINKFLAGS=
  DLLFLAGS=
else
  OPTFLAGS=-O2 -Wall -pedantic
  LINKFLAGS=-s
  DLLFLAGS=-s
endif
CFLAGS=$(OPTFLAGS) -I../../include

all: ../../../bin/Rgui.exe ../../../bin/Rterm.exe \
     ../../../bin/Rcmd.exe  ../../../bin/RSetReg.exe  \
    ../../../bin/Rproxy.dll

../../../bin/Rgui.exe: Rgui.exe
	$(MKDIR) -p ../../../bin
	$(CP) $^ $@

../../../bin/Rterm.exe: Rterm.exe
	$(MKDIR) -p ../../../bin
	$(CP) $^ $@	

../../../bin/Rcmd.exe: Rcmd.exe
	$(MKDIR) -p ../../../bin
	$(CP) $^ $@

../../../bin/RSetReg.exe: RSetReg.exe
	$(MKDIR) -p ../../../bin
	$(CP) $^ $@

graphappmain.o: ../graphapp/graphappmain.c
	$(CC) -c -o $@ -I../graphapp $(CFLAGS) $^

rgui-CFLAGS=-DWin32
rterm-CFLAGS=-DWin32
Rgui-LINKFLAGS=-mwindows

Rterm-LIBS=-luser32 -L.. -lR
Rgui-LIBS=-L.. -lR
Rpwd-LIBS=-lkernel32

Rgui.exe: graphappmain.o  rgui.o rgico.o

Rterm.exe: graphappmain.o rterm.o rtico.o

Rcmd.exe: rcmd.o ../rhome.o rcico.o

RSetReg.exe: RSetReg.o ../rhome.o rcico.o

Rpwd:
	$(MAKE) -C ../fixed version
	$(MAKE) Rpwd.exe

Rpwd.exe: rpwd.o rcico.o

rgui.o rterm.o rproxy_impl.o rgico.o rtico.o rcico.o: ../../include/Rversion.h

clean:
	$(RM) *.o *.obj *.exe *~ *.exp *.def *.dll *.lib

bdx-CFLAGS=-I../../include
rproxy-DLLFLAGS=-mwindows
rproxy-DLLLIBS=-L.. -lR
rproxy.dll: rproxy.o rproxy_dev.o rproxy_impl.o bdx.o rtico.o

../../../bin/Rproxy.dll: rproxy.dll
	$(MKDIR) -p ../../../bin
	$(CP) $^ $@

=== src/gnuwin32/graphapp/Makefile ===
include ../MkRules

ifdef DEBUG
  DEBUGFLAG=-g
else
  DEBUGFLAG=
endif

CFLAGS=-I. -I.. -I../../include -Wall $(DEBUGFLAG)  -O2 -DINDLL -DR_DLL_BUILD
SOURCES=$(filter-out graphappmain.c, $(wildcard *.c))
OBJS=$(foreach i, $(SOURCES), $(basename $i).o)

../ga.a: $(OBJS)

clean:
	$(RM) *.o *.a *~ \#*\#

#dependencies
arith.o: graphapp.h
array.o: internal.h ga.h graphapp.h
bitmap.o: internal.h ga.h graphapp.h
buttons.o: internal.h ga.h graphapp.h
clipboard.o: internal.h ga.h graphapp.h ../rui.h
context.o: internal.h ga.h graphapp.h
controls.o: internal.h ga.h graphapp.h
drawing.o: internal.h ga.h graphapp.h
drawtext.o: internal.h ga.h graphapp.h
events.o: internal.h ga.h graphapp.h
fonts.o: internal.h ga.h graphapp.h
gbuttons.o: internal.h ga.h graphapp.h
gdraw.o: internal.h ga.h graphapp.h
gimage.o: ga.h graphapp.h
gmenus.o: internal.h ga.h graphapp.h
graphappmain.o: internal.h ga.h graphapp.h
image.o: internal.h ga.h graphapp.h
init.o: internal.h ga.h graphapp.h
menus.o: internal.h ga.h graphapp.h
metafile.o: internal.h ga.h graphapp.h ../rui.h
objects.o: internal.h ga.h graphapp.h
printer.o: internal.h ga.h graphapp.h ../rui.h
rgb.o: ga.h graphapp.h
status.o: internal.h ga.h graphapp.h
stdimg.o: graphapp.h
strings.o: internal.h ga.h graphapp.h
tooltips.o: internal.h ga.h graphapp.h
windows.o: internal.h ga.h graphapp.h
xredef.o: internal.h ga.h graphapp.h

=== src/gnuwin32/help/Makefile ===
# default target builds indices
DOS=# -dosnames   # for file-name mapping
PERL=R_OSTYPE=windows perl
CAT=cat
CP=cp
RM=rm
MKDIR=mkdir

RHOME=$(shell perl ../pwd.pl ../../..)
PKGDIR=../../library
RLIB=$(RHOME)/library

indices:
	@PERL5LIB=$(RHOME)/share/perl $(PERL) \
	  ../../../share/perl/build-help-windows.pl ${DOS} -htmllists

pkg-% help-%:
	@PERL5LIB=$(RHOME)/share/perl $(PERL) \
	  ../../../share/perl/build-help-windows.pl ${DOS} \
	  -txt -html -example -latex $(PKGDIR)/$* $(RLIB)

chm-%:
	@PERL5LIB=$(RHOME)/share/perl $(PERL) \
	  ../../../share/perl/build-help-windows.pl ${DOS} \
	  -chm $(PKGDIR)/$* $(RLIB)
# hhc always gives an error code
	@$(MAKE)  --no-print-directory -C $(PKGDIR)/$*/chm \
	  -f $(RHOME)/src/gnuwin32/help/Makefile $*.chm
	@$(MKDIR) -p $(RLIB)/$*/chtml
	@$(CP) $(PKGDIR)/$*/chm/$*.chm $(RLIB)/$*/chtml

winhlp-%: chm-%
	$(MAKE) --no-print-directory -C $(PKGDIR)/$*/chm \
	  -f $(RHOME)/src/gnuwin32/help/Makefile $*.hlp
	$(MKDIR) -p $(RLIB)/$*/winhlp
	$(CP) $(PKGDIR)/$*/chm/$*.cnt $(PKGDIR)/$*/chm/$*.hlp $(RLIB)/$*/winhlp

# need not have HTML installed when building packages
contents-%:
	@PERL5LIB=$(RHOME)/share/perl $(PERL) \
	  ../../../share/perl/Rd2contents.pl \
	  --os=windows -o $(RLIB)/$*/CONTENTS $(PKGDIR)/$*
	@$(MKDIR) -p $(RHOME)/doc/html/search
	@$(CAT) $(RHOME)/library/*/CONTENTS > $(RHOME)/doc/html/search/index.txt
	@PERL5LIB=$(RHOME)/share/perl $(PERL) \
	  ../../../share/perl/build-help-windows.pl ${DOS} -htmllists

ziphelp-%:
	@$(MAKE) --no-print-directory -C $(RLIB)/$* \
	  -f $(RHOME)/src/gnuwin32/help/Makefile ZIPFLAGS=jqX  PKG=$* zipit

ziponlyhelp-%:
	@$(MAKE) --no-print-directory -C $(RLIB)/$* \
	  -f $(RHOME)/src/gnuwin32/help/Makefile ZIPFLAGS=jqmX PKG=$* zipit


winhelp-%:
	$(MAKE) --no-print-directory -C $(PKGDIR)/$* \
	  -f $(RHOME)/src/gnuwin32/help/Makefile PKG=$* win

latex-%:
	@$(MAKE) --no-print-directory -C $(RLIB)/$* \
	-f $(RHOME)/src/gnuwin32/help/Makefile PKG=$* unzipit
	PERL5LIB=$(RHOME)/share/perl $(PERL) \
	  ../../../share/perl/build-help-windows.pl ${DOS} -latex $(PKGDIR)/$*

clean:
	$(RM) -fr *~ *.o *.obj *.dll *.def *.a

# to be run from src/library/pkg/chm

HTM = $(filter-out 00Index.html, $(wildcard *.html))
%.chm: $(HTM) Rchm.css logo.jpg
	@hhc $*.hhp || exit 0

%.hlp: %.rtf logo.bmp
	hcrtf /x $*.hpj

%.rtf: $(HTM)
	perl $(RHOME)/share/perl/hhw-to-rtf.pl $*.hhp

Rchm.css: $(RHOME)/src/gnuwin32/help/Rchm.css
	@$(CP) $^ $@

logo.jpg: $(RHOME)/doc/html/logo.jpg
	@$(CP) $^ $@

logo.bmp: $(RHOME)/src/gnuwin32/help/logo.bmp
	@$(CP) $^ $@

# following are designed to be run from the library/pkg directory:

zipit: help/Rhelp.zip zipup
unzipit:
	-@$(MAKE) --no-print-directory -C latex \
	  -f $(RHOME)/src/gnuwin32/help/Makefile uz-Rhelp

help/Rhelp.zip: $(wildcard ../../src/library/$(PKG)/man/*.Rd \
../../src/library/$(PKG)/man/windows/*.Rd)
	-@if test -d help ; then \
	  $(MAKE) --no-print-directory -C help  \
            -f $(RHOME)/src/gnuwin32/help/Makefile uz-Rhelp; \
	fi
	-@if test -d R-ex ; then \
	  $(MAKE) --no-print-directory -C R-ex \
	    -f $(RHOME)/src/gnuwin32/help/Makefile uz-Rex; \
	fi
	-@if test -d latex ; then \
	  $(MAKE) --no-print-directory -C latex \
	    -f $(RHOME)/src/gnuwin32/help/Makefile uz-Rhelp; \
	fi
	-$(MAKE) --no-print-directory -C $(RHOME)/src/gnuwin32/help help-$(PKG)
	@$(RM) -f help/Rhelp.zip latex/Rhelp.zip R-ex/Rex.zip

zipup:
	@zip -${ZIPFLAGS} help/Rhelp help/* -x help/AnIndex 2> /dev/null || exit 0
	@zip -${ZIPFLAGS} R-ex/Rex R-ex/*.R 2> /dev/null || exit 0
	@zip -${ZIPFLAGS} latex/Rhelp latex/*.tex 2> /dev/null || exit 0

uz-%:
	@if test -f $*.zip ; then \
	  unzip -qou $*; \
	fi

=== src/gnuwin32/installer/Makefile ===
# Makefile for R for Windows Installers

include ../MkRules
include ../RWVERSION

all: SetupR.exe miniR.exe
clean: ISclean
distclean: ISdistclean

# section for JR software installer.

RECOMMENDED=KernSmooth VR boot cluster foreign mgcv nlme rpart survival grid lattice
EXTRA=

R.iss: JRins.pl ../$(RPREFIX)b.zip ../$(RPREFIX)h.zip \
../$(RPREFIX)ch.zip ../$(RPREFIX)d1.zip ../$(RPREFIX)d2.zip \
../$(RPREFIX)l.zip ../$(RPREFIX)sp.zip ../$(RPREFIX)w.zip
	unzip -qo ../$(RPREFIX)b
	unzip -qo ../$(RPREFIX)h
	unzip -qo ../$(RPREFIX)ch -d $(RPREFIX)ch
	unzip -qo ../$(RPREFIX)d1 -d $(RPREFIX)d1
	unzip -qo ../$(RPREFIX)d2 -d $(RPREFIX)d2
	unzip -qo ../$(RPREFIX)l -d $(RPREFIX)l
	unzip -qo ../$(RPREFIX)sp -d $(RPREFIX)sp
	unzip -qo ../$(RPREFIX)w -d $(RPREFIX)w
	for p in $(RECOMMENDED) $(EXTRA); do \
	  unzip -qo $(PKGS)/$${p} -d $(RPREFIX)/library; \
	done
	zip -rmq foo.zip $(RPREFIX)/library/*/html
	unzip -qo foo -d $(RPREFIX)w
	rm foo.zip
	zip -rmq foo.zip $(RPREFIX)/library/*/chtml
	unzip -qo foo -d $(RPREFIX)ch
	rm foo.zip
	zip -rmq foo.zip $(RPREFIX)/library/*/latex
	unzip -qo foo -d $(RPREFIX)l
	rm foo.zip
	rm -rf $(RPREFIX)/library/*/man
	$(CAT) $(RPREFIX)/library/*/CONTENTS >  \
	  $(RPREFIX)w/$(RPREFIX)/doc/html/search/index.txt
	$(CP) $(RPREFIX)w/$(RPREFIX)/doc/html/packages-head.html $(RPREFIX)/doc/html
	echo "make.packages.html(.Library)" | $(RPREFIX)/bin/rterm --vanilla --slave
	$(CP) $(RPREFIX)/doc/html/packages.html $(RPREFIX)w/$(RPREFIX)/doc/html
	$(RM) $(RPREFIX)/doc/html/packages*
	perl JRins.pl $(RPREFIX)


SetupR.exe: R.iss
	"$(ISDIR)/iscc" R.iss > setupR.log

Rsmall.iss: JRsmall.pl ../$(RPREFIX)b.zip \
  ../$(RPREFIX)h.zip ../$(RPREFIX)ch.zip ../$(RPREFIX)d1.zip
	rm -rf $(RPREFIX)*
	unzip -qo ../$(RPREFIX)b
	unzip -qo ../$(RPREFIX)h
	unzip -qo ../$(RPREFIX)ch -d $(RPREFIX)ch
	unzip -qo ../$(RPREFIX)d1 -d $(RPREFIX)d1
	rm $(RPREFIX)d1/$(RPREFIX)/doc/manual/R-admin.pdf
	rm $(RPREFIX)d1/$(RPREFIX)/doc/manual/R-exts.pdf
	rm $(RPREFIX)d1/$(RPREFIX)/doc/manual/R-lang.pdf
	for p in $(RECOMMENDED); do \
	  unzip -qo $(PKGS)/$${p} -d $(RPREFIX)/library; \
	done
	rm -rf $(RPREFIX)/library/*/html $(RPREFIX)/library/*/latex \
	  $(RPREFIX)/library/*/man
	rm -rf $(RPREFIX)/library/rpart/Manuscript
	rm -rf $(RPREFIX)/library/survival/doc $(RPREFIX)/library/survival/survival.ps.gz
	perl JRsmall.pl $(RPREFIX)

miniR.exe: Rsmall.iss
	"$(ISDIR)/iscc" Rsmall.iss > miniR.log

ISclean:
	rm -rf R.iss Rsmall.iss *.log $(RPREFIX)*

ISdistclean: ISclean
	rm -f SetupR.exe miniR*

=== debian/changelog ===
r-base (1.4.1.cvs20020414-2) unstable; urgency=low

  * debian/control: Added virtual fortran77-compiler, c-compiler to the
    list of alternative compilers that r-base-dev Depends: on

 --

r-base (1.4.1.cvs20020414-1) unstable; urgency=low

  * Upgraded to new release candidate 2002-04-14 of R 1.5.0

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 13 Apr 2002 20:48:59 -0500

r-base (1.4.1.cvs20020407-1) unstable; urgency=low

  * Upgraded to new release candidate 2002-04-07 of R 1.5.0

 -- Dirk Eddelbuettel <edd@debian.org>  Sun,  7 Apr 2002 07:59:43 -0500

r-base (1.4.1.cvs20020331-1) unstable; urgency=low

  * Upgraded to new release candidate 2002-03-23 of R 1.5.0

  * debian/control: Build-Depends on texinfo (>= 4.1-2) to ensure that 
    we will not be bitten by the epsf.tex bug 
  
 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 31 Mar 2002 08:55:08 -0600

r-base (1.4.1.cvs20020323-1) unstable; urgency=low

  * Upgraded to new release candidate 2002-03-23 of R 1.5.0

  * debian/control: New packages r-base-core, r-base-html, r-base-latex 
    and r-doc-info have been split from the old r-base package which now 
    Depends: on these, but can also be removed -- this adds some extra
    flexibility and can save over eight megabytes of installed files.
  * debian/control: Replaces: r-base (<= 1.4.1-1) for the new packages

  * debian/rules: Fortan compiler selection adapted to new upstream configure
  * debian/control: r-base Suggests: r-base-dev instead of gcc
  * debian/copyright: Updated and included current COPYRIGHTS file ...
  * debian/rules: ... and therefore do not install COPYRIGHTS separately
  * debian/control: Added Build-Depends on texi2html (split from tetex-bin)
  
 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 23 Mar 2002 11:17:48 -0600

r-base (1.4.1-1) unstable; urgency=low

  * Upgraded to new upstream release 1.4.1

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 30 Jan 2002 18:50:34 -0600

r-base (1.4.0.cvs20020124-1) unstable; urgency=low

  * Upgraded to the R-patched_2002-01-24 release candidate for 1.4.1

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 24 Jan 2002 19:38:34 -0600

r-base (1.4.0-1) unstable; urgency=low

  * Upgraded to new upstream release 1.4.0
  * debian/control: Add lib{zvt,gtkxmhtml}-dev to Build-Depends [thanks, Doug]
  * debian/control: Fixed hppa Build-Depends [thanks, Matthew Wilcox]
  * debian/rules: Minor cleanup regarding configuration options
  * debian/control: Changed Priority: from extra to optional
  * debian/control: Corrected r-doc-html Description [thanks, Doug Bates]
  * debian/control: Spelling corrections (Closes: #125300)
  
 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 19 Dec 2001 18:47:46 -0600

r-base (1.3.1-6) unstable; urgency=low

  * debian/rules: Also apply s/-lg2c/-lg2c-pic/ on etc/Makeconf
  * debian/control: Revert to Arch: all for doc packages, no Depends r-base
  * debian/control: r-base-dev Depends remodelled on r-base Build-Depends

 -- Dirk Eddelbuettel <edd@debian.org>  Mon,  3 Dec 2001 21:58:40 -0600

r-base (1.3.1-5) unstable; urgency=low

  * debian/rules: Unset CPPFLAGS, LIBS before calling configure to not
    leave traces of /usr/local. Thanks, Kurt Hornik (Closes: #71917)
  * debian/rules: More s/-lg2c/-lg2c-pic/ substitution in src/library/
  * debian/control: Added new package r-mathlib (Closes: #119701)
  * debian/control: Added new package r-doc-html (R manuals in html format)
  * debian/rules: Added suitable rules for r-mathlib and r-doc-html
  * debian/rules: Rewritten/cleaned for DH_COMPAT=3
  
 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 16 Nov 2001 20:43:24 -0600

r-base (1.3.1-4) unstable; urgency=low

  * debian/control: Corrected maintainer email
  * debian/rules: Do not run 'make check' on arm as it stumbles over the
    Bessel example; this known misfeature has long been reported upstream
  * debian/README.Atlas: Updated to reflect autoMAGIC loading of Atlas lib
    with ldconfig from libc6_2.2.4-5 or later -- thanks, Ben Collins!
  
 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 11 Nov 2001 11:19:10 -0600

r-base (1.3.1-3) unstable; urgency=low

  * New maintainer
  * debian/rules: Substitute -lg2c-pic for -lg2c in Makeconf [Thanks, Jeff!]
  * debian/control: Following advice from the Release Manager, let r-doc-pdf
    and r-base-dev be Arch: any as they Depends: on r-base itself 
  * debian/rules: configure with tkConfig.sh,tclConfig.sh for 8.3 support
  * debian/control: Build-Depends on tcl8.3-dev and tk8.3-dev
  * debian/rules: Let ia64 use gcc-3.0, g77-3.0, g++-3.0
  * debian/control: Build-Depends adjusted accordingly

 -- Dirk Eddelbuettel <edd@debian.org>  Fri,  9 Nov 2001 20:17:43 -0600

r-base (1.3.1-2) unstable; urgency=low

  * Non-maintainer upload, coordinated with the maintainer
  * Fixed local teTeX issue so that pdf manuals are built (Closes: #112184)
  * debian/*.links: link r-doc-pdf, r-gnome, r-base-dev doc dir to r-base
  * debian/*.preinst: rm doc dir for r-doc-pdf, r-gnome, r-base-dev 
  * debian/control: r-base-dev and r-doc-pdf now depend on r-base
  
 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 14 Sep 2001 21:53:24 -0500

r-base (1.3.1-1) unstable; urgency=low

  * Non-maintainer upload, coordinated with the maintainer
  * Upgraded to new upstream release 1.3.1
  * src/scripts/R.sh.in: Modified to detect libs from /etc/ld.so.conf so
    that Atlas is now used automatically when installed, providing very
    significant performance gains. Thanks for Kurt Hornik for the sed magic. 
  * debian/control: Build-Depends for f2c on m68k, g77 everywhere else
  * debian/rules: Use f2c on m68k, g77 everywhere else
  * debian/rules: Compile with -O on m68k, -O2 everywhere else. Thanks 
    to Christian Steigies for countless m68k tests and compilations 
  * debian/r-base.lintian: Added Lintian excpeptions clauses:
    -- for files not under md5sum creation as their content changes
    -- for spurious 'extra license' on license() command documentation


=== debian/control ===
Source: r-base
Section: math
Priority: optional
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Standards-Version: 3.5.0
Build-Depends: blas-dev (>= 1.0-9), libgnome-dev, libzvt-dev, libgtkxmhtml-dev, tcl8.3-dev, tk8.3-dev, libglade-gnome0-dev, bison, g77 [!m68k !ia64], g77-3.0 [ia64], f2c [m68k], gcc-3.0 [ia64], g++-3.0 [ia64], groff-base, libncurses5-dev, libreadline4-dev, tetex-bin, tetex-extra, debhelper (>= 3.0.0), texi2html, texinfo (>= 4.1-2)

Package: r-base
Architecture: all
Depends: r-base-core, r-base-html, r-base-latex
Suggests: libpaperg, ess, r-doc-info | r-doc-pdf | r-doc-html
Description: GNU R statistical computing language and environment
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 S is the statistician's Matlab and R is to S what Octave is to Matlab.
 .
 This packages is a meta-package which eases the transition from the 
 pre-1.5.0 package setup with its larger r-base package. Once installed, it 
 can be safely removed and apt-get will automatically upgrade its components
 during future upgrades.  Providing this packages gives a way to users to 
 then only install r-base-core (but not, say, r-base-latex) if they so desire.

Package: r-base-core
Architecture: any
Depends: ${perl:Depends}, zlib-bin, ${shlibs:Depends}
Replaces: r-base (<= 1.4.1-1)
Recommends: r-recommended, r-base-dev
Description: GNU R core of statistical computing language and environment
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 S is the statistician's Matlab and R is to S what Octave is to Matlab.
 .
 This package provides the core GNU R system from which only the optional
 documentation packages r-base-html, r-base-latex, r-doc-html, r-doc-pdf 
 and r-doc-info have been split off to somewhat reduce the size of this 
 package. 

Package: r-gnome
Architecture: any
Depends: r-base-core (= ${Source-Version}), ${shlibs:Depends}
Description: GNU R Gnome gui for statistical computing system
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This package provides the dynamic link libraries needed to start GNU R
 with the GNOME libraries frontend as in "R --gui=GNOME"

Package: r-base-dev
Architecture: all
Depends: r-base-core, blas-dev (>= 1.0-9), build-essential, g77 | g77-3.0 | f2c | fortran77-compiler , gcc | gcc-3.0 | c-compiler, g++ | g++-3.0
Description: GNU R installation of auxiliary GNU R packages 
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages ensures that other Debian packages needed for installation of
 some auxiliary R packages are installed.

Package: r-mathlib
Architecture: any
Depends: r-base-core, r-base-dev
Description: GNU R standalone mathematics library
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides the libRmath shared and static libraries which can
 be called from standalone C or C++ code.

Package: r-base-html
Architecture: all
Priority: extra
Depends: r-base-core
Replaces: r-base (<= 1.4.1-1)
Description: GNU R html docs for statistical computing system functions
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides html documentation suitable for browsing with a 
 web-browser for the libraries included in the r-base package. It is not 
 a required package as the same documentation is already included for 
 on-line browsing. 

Package: r-base-latex
Architecture: all
Priority: extra
Depends: r-base-core
Replaces: r-base (<= 1.4.1-1)
Description: GNU R LaTeX docs for statistical computing system functions
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides latex documentation suitable for off-line printing
 for the libraries included in the r-base package. It is not a required 
 package as the same documentation is already included for on-line browsing.

Package: r-doc-pdf
Architecture: all
Section: doc
Suggests: r-base-core, xpdf | acroread | pdf-viewer
Description: GNU R pdf manuals for statistical computing system
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides the R manuals in pdf format. The sibling packages
 r-doc-html and r-doc-info provides the same manuals.

Package: r-doc-html
Architecture: all
Section: doc
Suggests: r-base-core, mozilla | konqueror | links | lynx | www-browser
Replaces: r-base (<= 1.4.1-1)
Description: GNU R html manuals for statistical computing system
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides the R manuals in html format. The sibling packages
 r-doc-pdf and r-doc-info provides the same manuals.

Package: r-doc-info
Architecture: all
Section: doc
Replaces: r-base (<= 1.4.1-1)
Suggests: r-base-core, info (>= 3.12) | info-browser
Description: GNU R info manuals statistical computing system
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides the R manuals in info format. The sibling packages
 r-doc-html and r-doc-pdf provide the same manuals.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules file for the Debian GNU/Linux r-base package
# Copyright 1997-2001 by Douglas Bates <bates@stat.wisc.edu>, <edd@debian.org>
# Copyright 2001-2002 by Dirk Eddelbuettel <edd@debian.org>

# $Id: rules,v 1.40 2002/04/22 22:05:38 bates Exp $

corepackage	= r-base-core
latexpackage	= r-base-latex
pdfpackage	= r-doc-pdf
htmlpackage	= r-doc-html
gnomepackage	= r-gnome
nmathpackage	= r-mathlib

# for the standalone library, no sonames are assigned in the upstream Makefiles
somaj		= 1
somin		= 0
sorel		= 0
libver		= $(somaj).$(somin).$(sorel)

debbase		:= $(CURDIR)/debian
debtmp		:= $(debbase)/tmp
debdoc		:= $(debbase)/$(corepackage)/usr/share/doc/$(corepackage)
debmat		:= $(debbase)/$(nmathpackage)

arch		:= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

## set this to 1 if you want the skip the pdf creation and tests
#skipparts	= 1

# set this to 1 (default) if you want the Gnome GUI package
gnome		= 1
ifeq ($(gnome),0)
gnomeconfig 	= --without-gnome
else
gnomeconfig	= --with-gnome
endif

#export DH_VERBOSE = 1
export DH_COMPAT  = 3

# edd 15 Aug 2001: default to blas, atlas can override it 
atlas = --with-blas=blas

# edd 02 Sep 2001: default to g77 but let m68k use f2c
fortrancompiler	= F77=g77
compiler	= gcc
cxxcompiler	= g++

# edd 04 Sep 2001  default compiler flags, lowered for m68k
compilerflags	= -O2
# m68k barks when using g77, and when gcc use -O2
ifeq ($(arch),m68k-linux)
fortrancompiler	= F2C=f2c
compilerflags	= -O
endif

## edd 09 Nov 2001  ia64 needs gcc-3.0, hppa gets it by default
ifeq ($(arch),ia64-linux)
fortrancompiler = F77=g77-3.0
compiler	= gcc-3.0
cxxcompiler	= g++-3.0
compilerflags	= -O2
endif

## lamont@debian.org 06 Dec 2001  hppa needs -ffunction-sections  
ifeq ($(arch),hppa-linux)
compilerflags   = -O2 -ffunction-sections
endif

## try gcc-3.0 on i386 -- appears to work
#ifeq ($(arch),i386-linux)
#fortrancompiler= F77=g77-3.0
#compiler	= gcc-3.0
#cxxcompiler	= g++-3.0
#compilerflags	= -O2
#endif

get-orig-source: upstream
upstream:
	links http://cran.us.r-project.org

upstreamdevel:
	links ftp://ftp.stat.math.ethz.ch/Software/R

build: build-arch build-indep

build-arch: configure make-arch build-arch-stamp
build-arch-stamp:
	@echo "*** build-arch ***"
	touch build-arch-stamp

build-indep: configure make-indep build-indep-stamp
build-indep-stamp:
	@echo "*** build-indep ***"
	touch build-indep-stamp

configure: configure-stamp
configure-stamp:	
	@echo "*** configure ***"
	dh_testdir
	R_UNZIPCMD=/usr/bin/miniunzip			\
	R_ZIPCMD=/usr/bin/minizip			\
	CC=${compiler}					\
	CXX=${cxxcompiler}				\
	${fortrancompiler}				\
	CPPFLAGS=					\
	LDFLAGS=					\
	FLIBS=						\
	./configure --prefix=/usr			\
		    --with-tcltk			\
		    --with-tcl-config=/usr/lib/tcl8.3/tclConfig.sh	\
		    --with-tk-config=/usr/lib/tk8.3/tkConfig.sh		\
		    --mandir=/usr/share/man		\
		    --infodir=/usr/share/info		\
		    $(atlas)				\
		    $(gnomeconfig)			\
		    --enable-R-profiling		\
		    --enable-R-shlib			\
		    --host $(arch)
# this should now be fixed upstream by KH
#        ## hppa and ia64 really need the PIC version of libg2c
#        ## for conformity we will use it throughout
#        perl -p -i -e "s/ -lg2c / -lg2c-pic /" Makeconf
#        ## same needed for lower-level library files
#	for i in ctest modreg mva ts; do 			\
#		perl -p -i -e "s/ -lg2c / -lg2c-pic /" 		\
#				src/library/$$i/src/Makefile; 	\
#	done
#        ## and etc/Makeconf	
#	perl -p -i -e "s/ -lg2c / -lg2c-pic /" etc/Makeconf
	touch configure-stamp

make-arch: configure make-arch-stamp 
make-arch-stamp: 
	@echo "*** make-arch ***"
	make		CFLAGS="$(compilerflags)"		\
			CXXFLAGS="$(compilerflags)"		\
			FFLAGS="$(compilerflags)"		\
			CC=${compiler} 				\
			CXX=${cxxcompiler}			\
			FC=${fortrancompiler}			\
			R
        # currently needed for binary package with docs [FIXME: how?]
	make docs

        # make standalone math lib
	(cd src/nmath/standalone; 				\
		make	CFLAGS="$(compilerflags) -D_REENTRANT"	\
			CXXFLAGS="$(compilerflags) -D_REENTRANT"\
			FFLAGS="$(compilerflags) -D_REENTRANT"	\
			CC=${compiler} 				\
			CXX=${cxxcompiler} 			\
			FC=${fortrancompiler}			\
			libRmath_la_LDFLAGS=-Wl,-soname,libRmath.so.$(somaj) \
			)
        # FIXME
	make html
        # currently needed for binary package [FIXME: into r-doc-help]
	make help
	touch make-arch-stamp

make-indep: configure make-indep-stamp
make-indep-stamp:
	@echo "*** make-indep ***"
        # FIXME would be nice here:   make docs
        #                             make help
        # currently needed for binary package [FIXME: into r-doc-info]
	make info
	make pdf
	touch make-indep-stamp

#make: configure make-arch make-stamp
#make-stamp: 
#        # Already made in general 'make': make html
#	touch make-stamp

check: configure make-arch check-stamp
check-stamp: 
	@echo "*** check ***"
ifneq	($(arch),arm-linux)
	-make check
endif
	touch check-stamp

clean:
	@echo "*** clean ***"
	dh_testdir
	dh_testroot
	rm -f 	configure-stamp \
		build-stamp build-indep-stamp build-arch-stamp \
		make-stamp make-arch-stamp make-indep-stamp \
		install-indep-stamp install-arch-stamp \
		check-stamp 
	-make distclean
	-rm -f `find . -name "*~"`
	-rm -rf debian/tmp debian/files* core debian/substvars
	-rm -f doc/html/function.html doc/html/packages.html
	-rm -f modules/*.so
        # left over in CVS from r-base --> r-base-core transition
	(cd debian; rm -vf r-base.dirs r-base.files r-base.lintian \
			r-base.menu r-base.postinst)	
	dh_clean

install: install-arch install-indep 

install-arch: make-arch check install-arch-stamp
install-arch-stamp: 
	@echo "*** install-arch ***"
	dh_testdir
	dh_testroot
	dh_clean -a -k
	dh_installdirs -A

	make    	prefix=$(debtmp)/usr   	 		\
			mandir=$(debtmp)/usr/share/man	 	install
        # set R_HOME_DIR env.var. in R shell script
	sed -e '/^R_HOME_DIR=.*/s::R_HOME_DIR=/usr/lib/R:' \
	  < bin/R > $(debtmp)/usr/bin/R
	sed -e '/^R_HOME_DIR=.*/s::R_HOME_DIR=/usr/lib/R:' \
	  < bin/R > $(debtmp)/usr/lib/R/bin/R

        # fix permissions (Lintian)
	chmod a+x 	$(debtmp)/usr/lib/R/share/sh/echo.sh \
			$(debtmp)/usr/lib/R/share/sh/help-links.sh

        # remove unneeded license files, but link them back
	rm -v 	$(debtmp)/usr/lib/R/COPYING 		\
		$(debtmp)/usr/lib/R/COPYING.LIB 
	(cd $(debtmp)/usr/lib/R/; \
		ln -s ../../share/common-licenses/GPL COPYING; \
		ln -s ../../share/common-licenses/LGPL COPYING.LIB)

        # move the GNOME version to the r-gnome package
ifneq ($(gnome),0)
	dh_movefiles	-p$(gnomepackage) 	usr/lib/R/modules/R_gnome.so
endif

        # move the html manual files in r-doc-html.files into r-doc-html 
        # these get built in make-arch too ...
	dh_movefiles	-p$(htmlpackage)		
        # move files for r-base-html
	dh_movefiles	-pr-base-html
        # move files for r-base-latex
	dh_movefiles	-pr-base-latex

        # move files for r-base-core
	dh_movefiles	-p$(corepackage)

        # for the standalone library package, move the two libs
        # as 'make install' ignore these, we have to do it by hand
	dh_installdirs -p$(nmathpackage) usr/include usr/lib
	install -m 0644 src/nmath/standalone/libRmath.a     \
			$(debmat)/usr/lib
	install -m 0644 src/nmath/standalone/libRmath.so    \
			$(debmat)//usr/lib/libRmath.so.$(libver)
	(cd $(debmat)/usr/lib; \
			ln -s libRmath.so.$(libver) libRmath.so.$(somaj))
        # and create a link for Rmath.h 
	(cd $(debmat)/usr/include; \
			ln -s ../lib/R/include/Rmath.h .)
	touch install-arch-stamp

#install-indep: make-arch make-indep install-arch install-indep-stamp
install-indep: make-indep install-indep-stamp
install-indep-stamp: 
	@echo "*** install-indep ***"
	dh_testdir
	dh_testroot
	dh_clean -a -k
	dh_installdirs -A

	make    	prefix=$(debtmp)/usr   	 		install-pdf

        # the indep package r-doc-info is made now 
	make    	prefix=$(debtmp)/usr  \
			infodir=$(debtmp)/usr/share/info	install-info

        # move the pdf manual files listed in r-doc-pdf.files into r-doc-pdf
